//  This file is part of ff3d - http://www.freefem.org/ff3d
//  Copyright (C) 2001, 2002, 2003 Stphane Del Pino

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2, or (at your option)
//  any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software Foundation,
//  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

//  $Id: AnalyticShape.cpp,v 1.2 2006/10/01 23:25:58 delpinux Exp $

#include <AnalyticShape.hpp>

ReferenceCounting<Shape> AnalyticShape::
__getCopy() const
{
  return new AnalyticShape(*this);
}

AnalyticShape::
AnalyticShape(ConstReferenceCounting<ScalarFunctionBase> function)
  : Shape(Shape::analytic),
    __function(function)
{
  ;
}

AnalyticShape::
AnalyticShape(const AnalyticShape& analyticShape)
  : Shape(analyticShape),
    __function(analyticShape.__function)
{
  ;
}

AnalyticShape::
~AnalyticShape()
{
  ;
}
